Part Module: Difference between revisions

From FreeCAD Documentation
(Moving detailed OCCT stuff to the OpenCASCADE page. Please keep in mind that this page is an introduction to the Part Workbench. When you open a book you do not want to see information that belongs in appendix Z on the first page. The same principle applies here.)
(Moving content of 'Scripting' paragraph to dedicated page (that already existed!). See 'appendix Z' comment of previous edit.)
Line 158: Line 158:


<!--T:56-->
<!--T:56-->
{{Emphasis|See also:}} [[Part scripting|Part scripting]]
See [[Part scripting|Part scripting]].

<!--T:19-->
The main data structure used in the Part module is the [http://en.wikipedia.org/wiki/Boundary_representation BRep] data type from OpenCascade.
Almost all contents and object types of the Part module are available by [[Python|Python]] scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]] page, to know more.

<!--T:63-->
The most basic object that can be created is a [[Part Feature|Part Feature]], which has a simple {{PropertyData|Placement}} property, and basic properties to define its color and appearance.

<!--T:64-->
Another simple object used in 2D geometrical objects is [[Part Part2DObject|Part Part2DObject]], which is the base of [[Sketcher_SketchObject|Sketcher SketchObject]] ([[Sketcher Workbench|Sketcher]]), and most [[Draft Workbench|Draft elements]].

=== Test script === <!--T:69-->

<!--T:70-->
Test the creation of [[Part_Primitives|Part Primitives]] with a script. {{Version|0.19}}

</translate>
{{Code|code=
import parttests.part_test_objects as pto
pto.create_test_file("example_file")
}}
<translate>

<!--T:71-->
This script is located in the installation directory of the program, and can be examined to see how the basic primitives are built.
</translate>
{{Code|code=
$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py
}}
<translate>

=== Examples === <!--T:20-->

<!--T:21-->
To create a line element switch to the Python console and type in:

</translate>
{{Code|code=
import Part,PartGui
doc=App.newDocument()
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape()
doc.recompute()
}}
<translate>

<!--T:22-->
Let's go through the above python example step by step:

</translate>
{{Code|code=
import Part,PartGui
doc=App.newDocument()
}}
<translate>

<!--T:23-->
loads the Part module and creates a new document

</translate>
{{Code|code=
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
}}
<translate>

<!--T:24-->
Line is actually a line segment, hence the start and endpoint.

</translate>
{{Code|code=
doc.addObject("Part::Feature","Line").Shape=l.toShape()
}}
<translate>

<!--T:25-->
This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

</translate>
{{Code|code=
doc.recompute()
}}
<translate>

<!--T:26-->
Updates the document. This also prepares the visual representation of the new part object.

<!--T:27-->
Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

<!--T:72-->
A Line can be created also using:

</translate>
{{Code|code=
import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateLine(pt1, pt2, objName):
obj = DOC.addObject("Part::Line", objName)
obj.X1 = pt1[0]
obj.Y1 = pt1[2]
obj.Z1 = pt1[2]

obj.X2 = pt2[0]
obj.Y2 = pt2[1]
obj.Z2 = pt2[2]

DOC.recompute()
return obj

line = mycreateLine((0,0,0), (0,10,0), "LineName")

}}

<translate>


<!--T:28-->
A circle can be created in a similar way:

</translate>
{{Code|code=
import Part
doc = App.activeDocument()
c = Part.Circle()
c.Radius=10.0
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()
}}
<translate>

<!--T:73-->
or using:

</translate>
{{Code|code=
import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateCircle(rad, objName):
obj = DOC.addObject("Part::Circle", objName)
obj.Radius = rad

DOC.recompute()
return obj

circle = mycreateCircle(5.0, "CircleName")

}}

<translate>

<!--T:29-->
Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

</translate>
{{Code|code=
s = f.Shape
e = s.Edges[0]
c = e.Curve
}}
<translate>

<!--T:30-->
Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

<!--T:31-->
Head to the [[Topological data scripting|Topological data scripting]] page if you would like to know more.


== Tutorials == <!--T:34-->
== Tutorials == <!--T:34-->

Revision as of 07:59, 19 August 2020

Part workbench icon

Introduction

The solid modelling capabilities of FreeCAD are based on the OpenCASCADE Technology (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The Part Workbench is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ( Draft, Sketcher, PartDesign, etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.

The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. This modeling paradigm is known as the constructive solid geometry (CSG) workflow, and it was the traditional methodology used in early CAD systems. On the other hand, the PartDesign Workbench provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations (feature editing), until the final object is obtained.

Part objects are more complex than mesh objects created with the Mesh Workbench, as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD.

Tools

The tools are all located in the Part menu.

Primitives

These are tools for creating primitive objects.

  • Box: Draws a box by specifying its dimensions
  • Cylinder: Draws a cylinder by specifying its dimensions
  • Sphere: Draws a sphere by specifying its dimensions
  • Cone: Draws a cone by specifying its dimensions
  • Torus: Draws a torus (ring) by specifying its dimensions
  • Primitives: A tool to add any of the defined geometric primitives.
  • Shapebuilder: A tool to create more complex shapes from various parametric geometric primitives

Modifying objects

These are tools for modifying existing objects. They will allow you to choose which object to modify.

  • Extrude: Extrudes planar faces of an object
  • Revolve: Creates a solid by revolving another object (not solid) around an axis
  • Mirror: Mirrors the selected object on a given mirror plane
  • Fillet: Fillets (rounds) edges of an object
  • Chamfer: Chamfers edges of an object
  • Ruled Surface:
  • Loft: Lofts from one profile to another
  • Sweep: Sweeps one or more profiles along a path
  • Thickness: Hollows out a solid, leaving openings next to select faces.
  • Boolean: Performs boolean operations on objects
  • Union: Fuses (unions) two objects
  • Common: Extracts the common (intersection) part of two objects
  • Cut: Cuts (subtracts) one object from another

Measure

File:Std Measure Menu.png Measure: Allows linear and angular measurement between points, edges, and faces.

Other tools

Contextual Menu items

  • Appearance: determines appearance of the whole part (color transparency etc.).
  • Set colors: assigns colors to part faces.

Preferences

  • Preferences: preferences available for Part Tools (the Part workbench also uses the PartDesign Preferences).
  • Import Export Preferences: preferences available for importing from and exporting to different file formats.
  • Fine-tuning: some extra parameters to fine-tune Part behavior.

Scripting

See Part scripting.

Tutorials